/*
 *   Xfrisk - The classic board game for X
 *   Copyright (C) 1993-1999 Elan Feingold (elan@aetherworks.com)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *   $Id: deck.h,v 1.8 2003/05/13 23:32:56 sketch Exp $
 */

#ifndef DECK_H
#define DECK_H

#include "types.h"

typedef enum
    {
    CARD_CAVALRY,
    CARD_INFANTRY,
    CARD_ARTILLERY,
    CARD_JOKER,
    NUM_CARDTYPES
    } CardTypes;

struct _Deck;
typedef struct _Deck Deck;

Deck   *DECK_Create( Int32 iNumCards );
Int32   DECK_GetCard( Deck *pDeck );
void    DECK_PutCard( Deck *pDeck, Int32 iCard );
void    DECK_Destroy( Deck *pDeck );
Int32   DECK_ExchangeCards( Deck *pDeck, Int32 *piCards );

#endif /* DECK_H */

/* End of file */
