/*
 *   Xfrisk - The classic board game for X
 *   Copyright (C) 1993-1999 Elan Feingold (elan@aetherworks.com)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *   $Id: server.h,v 1.15 2003/07/13 18:10:24 morphy Exp $
 */

/** \file
 * Interface definitions for server
 */

#ifndef SERVER_H
#define SERVER_H

#include "types.h"

/* Initialization, reset and game startup */
void     SRV_Init( void );
void     SRV_Reset( void );
void     SRV_PlayGame( void );
void     SRV_Usage ( const char *progname );
void     SRV_Version ( const char *progname );

/* Message broadcast & data replication */
void     SRV_BroadcastTextMessage( CString strMessage );
void     SRV_BroadcastMessage( const Msgs *pMessage );

void     SRV_CompleteBroadcast( Int32 iClientExclude,
                                const Msgs *pMess );

void     SRV_Replicate( const Msgs *pMess,
                        Int32 iDirection,
                        Int32 iSrc );

/* Species handling */
Int32    SRV_AllocSpecies( void );
void     SRV_FreeSpecies( Int32 i );

/* Client failure handling & cleanup */
void     SRV_LogFailure( CString strReason, Int32 iCommLink );
void     SRV_RecoverFailures( void );
void     SRV_FreeClient( Int32 iClient );

#endif /* SERVER_H */

/* End of file */
