/*
 *   Xfrisk - The classic board game for X
 *   Copyright (C) 1993-1999 Elan Feingold (elan@aetherworks.com)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *   $Id: types.h,v 1.12 2003/05/13 23:32:56 sketch Exp $
 */

#ifndef TYPES_H
#define TYPES_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_STDINT_H

#undef _POSIX_C_SOURCE
#define _POSIX_C_SOURCE 200112L
#include <stdint.h>

/* http://www.opengroup.org/onlinepubs/007904975/basedefs/stdint.h.html */

typedef int32_t Int32;
typedef uint32_t UInt32;
typedef int16_t Int16;
typedef uint16_t UInt16;
typedef uint8_t Byte;

/* Character type */
typedef char Char;

/* Pointer type */
typedef intptr_t Pointer;

/*
 * Supplementary types
 */
typedef char           *CString;

typedef unsigned char   Flag;

#else /* HAVE_STDINT_H */

/* 32 bit integer */
#if SIZEOF_INT == 4

typedef int             Int32;
typedef unsigned int    UInt32;

#elif SIZEOF_LONG_INT == 4

typedef long int        Int32;
typedef unsigned long   UInt32;

#elif SIZEOF_SHORT_INT == 4

typedef short int       Int32;
typedef unsigned short  Int32;

#else
#error "No 32 bit integer type found"
#endif

/* 16 bit integer */
#if SIZEOF_INT == 2

typedef int             Int16;
typedef unsigned int    UInt16;

#elif SIZEOF_LONG_INT == 2

typedef signed long     Int16;
typedef unsigned long   UInt16;

#elif SIZEOF_SHORT_INT == 2

typedef short           Int16;
typedef unsigned short  UInt16;

#else
#error "No 16 bit integer type found"
#endif

/* 8 bit unsigned integer */
#if SIZEOF_INT == 1

typedef unsigned int    Byte;

#elif SIZEOF_LONG_INT == 1

typedef unsigned long   Byte;

#elif SIZEOF_SHORT_INT == 1

typedef unsigned short  Byte;

#elif SIZEOF_CHAR == 1

typedef unsigned char   Byte;

#else
#error "No 8 bit integer type found"
#endif

/* Character type */
typedef char Char;

/* Pointer type */
#if SIZEOF_INT == SIZEOF_VOID_P

typedef int             Pointer;

#elif SIZEOF_LONG_INT == SIZEOF_VOID_P

typedef long int        Pointer;

#elif SIZEOF_SHORT_INT == SIZEOF_VOID_P

typedef short int       Pointer;

#else
#error "No integer type with size equal to void * size found"
#endif

/*
 * Supplementary types
 */
typedef char           *CString;

typedef unsigned char   Flag;

#endif /* HAVE_STDINT_H */

#endif /* TYPES_H */

/* End of file */
